# Templates for ci jobs
# It defines workflow rules and templates to create docker images, to configure, build siconos and so on.

include:
   - ci/ci-templates.yml


# ---- Build docker images ----
ubuntu:22.04:docker-build:
  variables:
    IMAGE_NAME: ubuntu22.04
  extends: .docker-build      
      
fedora:38:docker-build:
  variables:
    IMAGE_NAME: fedora-38
  extends: .docker-build

debian:docker-build:
  variables:
    IMAGE_NAME: debian-bookworm
  extends: .docker-build
   
# ---- Devel pipeline (conf/build/test), one single distrib ----
ubuntu:configure:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
    CONF_FILE: configs/full_debug.cmake
  extends:
    - .soft-configure
    - .devel-rules

ubuntu:build:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
  extends:
    - .soft-build  
    - .devel-rules
  needs: ["ubuntu:configure"]
  

ubuntu:test:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
  extends:
    - .soft-test
    - .devel-rules
  needs: ["ubuntu:build"]

# ---- Other contexts, for MR or main branch ----
  
ubuntu_lite:configure:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
    CONF_FILE: configs/full_debug.cmake
  extends:
    - .soft-configure

ubuntu_lite:build:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
  extends:
    - .soft-build
  needs: ["ubuntu_lite:configure"]

ubuntu_lite:test:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
  extends:
    - .soft-test
  needs: ["ubuntu_lite:build"]

  
fedora:configure:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/fedora-38
    CONF_FILE: configs/minimal.cmake
  extends:
    - .soft-configure

fedora:build:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/fedora-38
  extends:
    - .soft-build
  needs: ["fedora:configure"]

fedora:test:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/fedora-38
  extends:
    - .soft-test
  needs: ["fedora:build"]

debian:configure:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/debian-bookworm
    CONF_FILE: configs/minimal.cmake
  extends:
    - .soft-configure

debian:build:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/debian-bookworm
  extends:
    - .soft-build
  needs: ["debian:configure"]

debian:test:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/debian-bookworm
  extends:
    - .soft-test
    - .full-rules

### install ###
ubuntu22.04:install:
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/ubuntu22.04
    RESULT_NAME: $CI_REGISTRY/pole-calcul-formation/outils-collaboratifs-gitlab/demos/ci-example-trigger/mysoft-ubuntu
  extends:
    - .soft-install
    - .devel-rules
  needs: ["ubuntu:build"]


# python
python:test:
  image: $CI_REGISTRY_IMAGE/ubuntu22.04
  stage: test
  script:
    - python3 -m venv pylab ; source pylab/bin/activate
    - python3 -m pip install pytest
    - python3 -m pip install $CI_PROJECT_DIR/python
    - pytest --junit-xml=pytest-report.xml $CI_PROJECT_DIR/python
  artifacts:
      paths:
        - pytest-report.xml
      expire_in: 2 days 
      reports:
        junit: pytest-report.xml
  needs: []
  extends:
    - .devel-rules

python:install:
  variables:
    RESULT_NAME: $CI_REGISTRY/pole-calcul-formation/outils-collaboratifs-gitlab/demos/ci-example-trigger/mypylab
  extends:
    - .notebook-install
    - .devel-rules
  needs: ["python:test"]

# Job run when a new tag (release) is created.
release_job:
    stage: release
    image: registry.gitlab.com/gitlab-org/release-cli:latest
    rules:
    - if: $CI_COMMIT_TAG                 # Run this job when a tag is created
      when: always
    script:
    - echo "running release_job"
    release:                               # See https://docs.gitlab.com/ee/ci/yaml/#release for available properties
      tag_name: '$CI_COMMIT_TAG'
      description: '$CI_COMMIT_TAG'

# Triggered job
# --- Creates a new pipeline to build documentation
# Trigger : manual.
# When the job is activated (manual trigger through the web interface),
# it starts a new pipeline, i.e. includes jobs declared in docs/build-doc.yml
generate-doc:
  stage: doc
  trigger:
    include:
      - docs/build-doc.yml
  when: manual
  needs: []

# start a job  in another project ...
bridge:example:
  variables:
    TRIGGERED: 1
  stage: doc
  trigger: 
    project: pole-calcul-formation/outils-collaboratifs-gitlab/demos/ci-example-trigger
    strategy: depend
  needs: ["ubuntu22.04:install"]
  extends: .devel-rules
  rules:
    - if: $CI_COMMIT_MESSAGE =~ /\[with example\]/
      when: always
    - when: never


